function res = measurePerformance(funcHandle,par,u,x,y,z,S,T,N,runs)

%shortcuts for some parameters
n_x = par.n_x;  % Number of continuous variables.
n_m = par.n_m;  % Number of discrete modes.

% INITIALISATION FOR THIS ITERATION =============================================
time     = -ones(1,runs);
map_errors   = -ones(1,runs);
mse      = -ones(1,runs);

z_map     = -ones(runs,T);

for iteration = 1:runs,
%	disp(['Iteration ', num2str(iteration), '/', num2str(runs)]);
	% INITIALISATION FOR THIS RUN ==============================================
    z_filter = -ones(T,N);          
    x_filter = -ones(n_x,T,N);
    z_num     = -ones(T,n_m);
	z_max     = -ones(T,1);
    
	% Filter ESTIMATION ========================================================
	[z_filter, x_filter, time(iteration)] = feval(funcHandle,N,T,par,u,y);
    x_err = mean(x_filter,3) - x;
	se = x_err.^2;
	mse(iteration) = mean(se(1,S:T));
	
	for t=1:T,
      for i=1:n_m,
        z_num(t,i)= length(find(z_filter(1,t,:)==i));
      end;
      [arb, z_max(t)] = max(z_num(t,:));  
	end;
	map_errors(iteration) = sum(z(S:T)~=z_max(S:T)');
    
    for i=1:N
        particle_errors(i) = sum(z_filter(1,S:T,i)~=z(S:T));
    end
    stddev(iteration) = sqrt(var(particle_errors));
    
    z_map(iteration,:) = z_max';
    z_est(:,:,iteration) = z_filter(1,:,:);
    x_est(:,:,:,iteration) = x_filter;
end;  % this run

res.mean_time = mean(time);
res.mean_error = mean(map_errors);
res.z_map = z_map;
res.mean_mse = mean(mse);
res.stddev_errors_between_particles = mean(stddev);
res.stddev_errors_between_runs = sqrt(var(map_errors));
res.stddev_mse = sqrt(var(mse));
%res.x_est = x_est;
%res.z_est = z_est;