[tmp size_pf] = size(pf);
[tmp size_upf] = size(upf);
[tmp size_gpf] = size(gpf);
[tmp size_gpf2] = size(gpf2);

pf_mean_time  = zeros(1,size_pf);
pf_mean_error = -10*ones(1,size_pf);
pf_stddev_b_p = -10*ones(1,size_pf);
pf_stddev_b_r = -10*ones(1,size_pf);
pf_mean_mse   = -10*ones(1,size_pf);
pf_stddev_mse = -10*ones(1,size_pf);
pf_zmax =       -10*ones(T,size_pf);

upf_mean_time  = zeros(1,size_upf);
upf_mean_error = -10*ones(1,size_upf);
upf_stddev_b_p = -10*ones(1,size_upf);
upf_stddev_b_r = -10*ones(1,size_upf);
upf_mean_mse   = -10*ones(1,size_upf);
upf_stddev_mse = -10*ones(1,size_upf);
upf_zmax =       -10*ones(T,size_upf);

gpf_mean_time  = zeros(1,size_gpf);
gpf_mean_error = -10*ones(1,size_gpf);
gpf_stddev_b_p = -10*ones(1,size_gpf);
gpf_stddev_b_r = -10*ones(1,size_gpf);
gpf_mean_mse   = -10*ones(1,size_gpf);
gpf_stddev_mse = -10*ones(1,size_gpf);
gpf_zmax =       -10*ones(T,size_gpf);

gpf2_mean_time  = zeros(1,size_gpf2);
gpf2_mean_error = -10*ones(1,size_gpf2);
gpf2_stddev_b_p = -10*ones(1,size_gpf2);
gpf2_stddev_b_r = -10*ones(1,size_gpf2);
gpf2_mean_mse   = -10*ones(1,size_gpf2);
gpf2_stddev_mse = -10*ones(1,size_gpf2);
gpf2_zmax =       -10*ones(T,size_gpf2);

for i = 1:size_pf
    pf_mean_time (i) = pf(i).mean_time;
    pf_mean_error(i) = pf(i).mean_error;
    pf_stddev_b_p(i) = pf(i).stddev_errors_between_particles;
    pf_stddev_b_r(i) = pf(i).stddev_errors_between_runs;    
    pf_mean_mse  (i) = pf(i).mean_mse;
    pf_stddev_mse(i) = pf(i).stddev_mse;
%    pf_zmax      (i) = pf(i).z_filter
end
for i = 1:size_upf
    upf_mean_time (i) = upf(i).mean_time;
    upf_mean_error(i) = upf(i).mean_error;
    upf_stddev_b_p(i) = upf(i).stddev_errors_between_particles;
    upf_stddev_b_r(i) = upf(i).stddev_errors_between_runs;    
    upf_mean_mse  (i) = upf(i).mean_mse;
    upf_stddev_mse(i) = upf(i).stddev_mse;
end
for i = 1:size_gpf
    gpf_mean_time (i) = gpf(i).mean_time;
    gpf_mean_error(i) = gpf(i).mean_error;
    gpf_stddev_b_p(i) = gpf(i).stddev_errors_between_particles;
    gpf_stddev_b_r(i) = gpf(i).stddev_errors_between_runs;    
    gpf_mean_mse  (i) = gpf(i).mean_mse;
    gpf_stddev_mse(i) = gpf(i).stddev_mse;
end
for i = 1:size_gpf2
    gpf2_mean_time (i) = gpf2(i).mean_time;
    gpf2_mean_error(i) = gpf2(i).mean_error;
    gpf2_stddev_b_p(i) = gpf2(i).stddev_errors_between_particles;
    gpf2_stddev_b_r(i) = gpf2(i).stddev_errors_between_runs;    
    gpf2_mean_mse  (i) = gpf2(i).mean_mse;
    gpf2_stddev_mse(i) = gpf2(i).stddev_mse;
end

plots =[];
legends = [];

figure(1)
hold off
title('Decreasing rate of diagnosis errors with available time for diagnosis');
hold on
xlabel('Time available for diagnosis per time step [s]');
ylabel('Rate of diagnosis errors [%]');
pf_plot = semilogx(pf_mean_time, pf_mean_error, 'bx-');
for i=1:size_pf
    X = pf_mean_time(i);
    X = [X X];
    Y = [pf_mean_error(i) - pf_stddev_b_r(i), pf_mean_error(i) + pf_stddev_b_r(i)];
    semilogx(X,Y,'b-');
end

upf_plot = semilogx(upf_mean_time, upf_mean_error, 'cx--');
for i=1:size_upf
    X = upf_mean_time(i);
    X = [X X];
    Y = [upf_mean_error(i) - upf_stddev_b_r(i), upf_mean_error(i) + upf_stddev_b_r(i)];
    semilogx(X,Y,'c--');
end

gpf_plot = semilogx(gpf_mean_time, gpf_mean_error, 'kx:');
for i=1:size_gpf
    X = gpf_mean_time(i);
    X = [X X];
    Y = [gpf_mean_error(i) - gpf_stddev_b_r(i), gpf_mean_error(i) + gpf_stddev_b_r(i)];
    semilogx(X,Y,'k:');
end

gpf2_plot = semilogx(gpf2_mean_time, gpf2_mean_error, 'rx-.');
for i=1:size_gpf2
    X = gpf2_mean_time(i);
    X = [X X];
    Y = [gpf2_mean_error(i) - gpf2_stddev_b_r(i), gpf2_mean_error(i) + gpf2_stddev_b_r(i)];
    semilogx(X,Y,'r-.');
end

legend([pf_plot, upf_plot, gpf_plot, gpf2_plot],'PF', 'UPF', 'GPF', 'GPF2');



plots =[];
legends = [];

figure(2)
hold off
title('Continuous state estimation errors with available time for diagnosis');
hold on
xlabel('Time available for diagnosis per time step [s]');
ylabel('Mean mean squared errors');
pf_plot = loglog(pf_mean_time, pf_mean_mse, 'bx-');
hold on
% for i=1:size_pf
%     X = pf_mean_time(i);
%     X = [X X];
%     Y = [max(1e-99, pf_mean_mse(i) - pf_stddev_mse(i)), pf_mean_mse(i) + pf_stddev_mse(i)];
%     loglog(X,Y,'b-');
% end

upf_plot = loglog(upf_mean_time, upf_mean_mse, 'cx--');
% for i=1:size_pf
%     X = upf_mean_time(i);
%     X = [X X];
%     Y = [max(1e-99, upf_mean_mse(i) - upf_stddev_mse(i)), upf_mean_mse(i) + upf_stddev_mse(i)];
%     loglog(X,Y,'c--');
% end

gpf_plot = loglog(gpf_mean_time, gpf_mean_mse, 'kx:');
% for i=1:size_gpf
%     X = gpf_mean_time(i);
%     X = [X X];
%     Y = [max(1e-99, gpf_mean_mse(i) - gpf_stddev_mse(i)), gpf_mean_mse(i) + gpf_stddev_mse(i)];
%     loglog(X,Y,'k:');
% end

gpf2_plot = loglog(gpf2_mean_time, gpf2_mean_mse, 'rx-.');
% for i=1:size_pf
%     X = gpf2_mean_time(i);
%     X = [X X];
%     Y = [max(1e-99, gpf2_mean_mse(i) - gpf2_stddev_mse(i)), gpf2_mean_mse(i) + gpf2_stddev_mse(i)];
%     loglog(X,Y,'r-.');
% end
legend([pf_plot, upf_plot, gpf_plot, gpf2_plot],'PF', 'UPF', 'GPF', 'GPF2');



plots =[];
legends = [];

figure(3)
hold off
title('Decreasing rate of diagnosis errors with more particles');
hold on
xlabel('Number of particles');
ylabel('Rate of diagnosis errors [%]');
nums = [];
for i=1:size_pf
    nums = [nums 2^(i-1)];
end
pf_plot = semilogx(nums, pf_mean_error, 'bx-');
hold on
for i=1:size_pf
    X = 2^(i-1);
    X = [X X];
    Y = [pf_mean_error(i) - pf_stddev_b_r(i), pf_mean_error(i) + pf_stddev_b_r(i)];
    semilogx(X,Y,'b-');
end

nums = [];
for i=1:size_upf
    nums = [nums 2^(i-1)];
end
upf_plot = semilogx(nums, upf_mean_error, 'cx--');
hold on
for i=1:size_upf
    X = upf_mean_time(i);
    X = 2^(i-1);
    Y = [upf_mean_error(i) - upf_stddev_b_r(i), upf_mean_error(i) + upf_stddev_b_r(i)];
    semilogx(X,Y,'c--');
end

nums = [];
for i=1:size_gpf
    nums = [nums 2^(i-1)];
end
gpf_plot = semilogx(nums, gpf_mean_error, 'kx:');
hold on
for i=1:size_gpf
    X = 2^(i-1);
    X = [X X];
    Y = [gpf_mean_error(i) - gpf_stddev_b_r(i), gpf_mean_error(i) + gpf_stddev_b_r(i)];
    semilogx(X,Y,'k:');
end

nums = [];
for i=1:size_gpf2
    nums = [nums 2^(i-1)];
end
gpf2_plot = semilogx(nums, gpf2_mean_error, 'rx-.');
for i=1:size_gpf2
    X = 2^(i-1);
    X = [X X];
    Y = [gpf2_mean_error(i) - gpf2_stddev_b_r(i), gpf2_mean_error(i) + gpf2_stddev_b_r(i)];
    semilogx(X,Y,'r-.');
end

legend([pf_plot, upf_plot, gpf_plot, gpf2_plot],'PF', 'UPF', 'GPF', 'GPF2');
hold off;


figure(4)
hold off
title('Discrete modes estimates on real data');
hold on
xlabel('Time steps');
ylabel('Observations and filter estimates');
y1_plot = plot(y(1,:),'g.-');
y2_plot = plot(y(2,:),'b.-');

%z_plot = plot(z,'r.-');

% only using the first run with the most particles.

pf_plot = plot(pf(size_pf).z_map(1,:),'r-');
%upf_plot = plot(upf(size_pf).z_map(1,:),'r.-');
%gpf_plot = plot(gpf(size_gpf).z_map(1,:),'g.-');
gpf2_plot = plot(gpf2(size_gpf2).z_map(1,:),'k--');

%legend([y1_plot, y2_plot, z_plot, pf_plot, upf_plot, gpf_plot, gpf2_plot],'Y1', 'Y2', 'true Z', PF', 'UPF', 'GPF', 'GPF2');
%legend([y1_plot, y2_plot, z_plot, pf_plot, gpf2_plot],'Y1', 'Y2', 'true Z', 'GPF', 'GPF2');
legend([y1_plot, y2_plot, pf_plot, gpf2_plot],'Y1', 'Y2', 'PF', 'GPF2');
hold off