function [T,u,x,y,z] = readData(par)

data = load('trajectory.dat'); 
% Make sure the trajectory matches the model. For generated data, you can run 
% sample_trajectory(par,ones(100,1)) to generate a new trajectory that's sampled using the model parameters.

T = size(data,1);

u = ones(1,T);   % Control Signal, set fix to 1.
x = zeros(par.n_x,T);
z = zeros(par.n_z,T);
y = zeros(par.n_y,T);


z = data(:,1:par.n_z)';                                  % discrete state
x = data(:,par.n_z+1:par.n_z+par.n_x)';                  % continuous state (only for determination of error)
y = data(:,par.n_z+par.n_x+1:par.n_z+par.n_x+par.n_y)';  % observed signal

z = z(:,1:T);
x = x(:,1:T);
y = y(:,1:T);