function x_new = ffun(z,z_before,x,par,u);
x_new = x;

% 6 cts variables: 1=LBogeyAngle (LB), 2=dLBogeyAngle (dLB), 3=DiffAngle (D), 
%                  4=dDiffAngle (dD), 5=RockWidth (B), 6=RockHeight (H)
% 6 modes: 1=Flat, 2=RockF, 3=RockM, 4=RockR, 5=RockFM, 6=RockMR


% no changes for z==1 (Flat) or z==6 (RockMR).
if z == 2 | z == 3 | z == 4      % RockF | RockM | RockR   
    B = 10;
    pisqr_over_Bsqr = zeros(1,size(x,2));
    for i=1:size(x,2)
        pisqr_over_Bsqr(1,i) = pi^2/B^2;
    end
%pisqr_over_Bsqr
  % dLB_t = dLB_{t-1} - pi^2/B_{t}^2*LB_{t-1};
    x_new(2,:) = x(2,:) - pisqr_over_Bsqr .* x(1,:);
  % dD_t = dD_{t-1} - pi^2/B_{t}^2*D_{t-1}; 
    x_new(4,:) = x(4,:) - pisqr_over_Bsqr .* x(3,:);
  
    if z~=z_before & (z == 2 | z == 3 | z == 4)
        [N M] = size(x(6,:));
        %=== Things that are different for z=2,3,4  
        if z == 2   % RockF
          % H_0 = -0.2
            x_new(6,:) = -0.2*ones(N,M);                
          % dD_0 = H*pi/(2*B); 
            x_new(4,:) = (pi*x_new(6,:)) ./ (2*B);
        elseif z == 3 %RockM
          % H_0 = 0.4
            x_new(6,:) = 0.4*ones(N,M);                
          % dD_0 = H*pi/(-4*B); 
            x_new(4,:) = (pi*x_new(6,:)) ./ (-4*B);
        elseif z == 4  %RockR
          % H_0 = -0.25
            x_new(6,:) = -0.25*ones(N,M);                
          % dD_0 = -0.8*H*pi/B; 
            x_new(4,:) = (-0.8*pi*x_new(6,:)) ./ B;          
       end
      %=== Things that are the same for z=2,3,4  
      % dLB_0 = H*pi/B;
        x_new(2,:) = (pi*x_new(6,:)) ./ B;
    
   end
elseif z == 5   % RockFM  dLB_t = 0; dD_t = 0    
    x_new(2,:) = x(2,:) * 0;
    x_new(4,:) = x(4,:) * 0;
end

x_new(1,:) = x(1,:) + x_new(2,:);   %% LB_t = LB_{t-1} + dLB_t
x_new(3,:) = x(3,:) + x_new(4,:);   %% D_t = D_{t-1} + dD



% % % % % % % % no changes for z==1 (Flat) or z==6 (RockMR).
% % % % % % % if z == 2 | z == 3 | z == 4      % RockF | RockM | RockR   
% % % % % % %     
% % % % % % %     % B = 10;
% % % % % % %     pisqr_over_Bsqr = zeros(1,size(x,2));
% % % % % % %     for i=1:size(x,2)
% % % % % % %         %pisqr_over_Bsqr(1,i) = pi^2/B^2;
% % % % % % %         pisqr_over_Bsqr(1,i) = pi^2/(x_new(5,i).^2);
% % % % % % %     end
% % % % % % % %pisqr_over_Bsqr
% % % % % % %   % dLB_t = dLB_{t-1} - pi^2/B_{t}^2*LB_{t-1};
% % % % % % %     x_new(2,:) = x(2,:) - pisqr_over_Bsqr .* x(1,:);
% % % % % % %   % dD_t = dD_{t-1} - pi^2/B_{t}^2*D_{t-1}; 
% % % % % % %     x_new(4,:) = x(4,:) - pisqr_over_Bsqr .* x(3,:);
% % % % % % %   
% % % % % % %     if z~=z_before & (z == 2 | z == 3 | z == 4)
% % % % % % %         [N M] = size(x_new(5,:));
% % % % % % %         x_new = 8*ones(N,M);
% % % % % % %         %=== Things that are different for z=2,3,4  
% % % % % % %         if z == 2   % RockF
% % % % % % %           % H_0 = -0.2
% % % % % % %             x_new(6,:) = -0.2*ones(N,M);                
% % % % % % %           % dD_0 = H*pi/(2*B); 
% % % % % % %             x_new(4,:) = (pi*x_new(6,:)) ./ (2*x_new(5,:));
% % % % % % %         elseif z == 3 %RockM
% % % % % % %           % H_0 = 0.4
% % % % % % %             x_new(6,:) = 0.4*ones(N,M);                
% % % % % % %           % dD_0 = H*pi/(-4*B); 
% % % % % % %             x_new(4,:) = (pi*x_new(6,:)) ./ (-4*x_new(5,:));
% % % % % % %         elseif z == 4  %RockR
% % % % % % %           % H_0 = -0.25
% % % % % % %             x_new(6,:) = -0.25*ones(N,M);                
% % % % % % %           % dD_0 = -0.8*H*pi/B; 
% % % % % % %             x_new(4,:) = (-0.8*pi*x_new(6,:)) ./ (x_new(5,:));          
% % % % % % %        end
% % % % % % %       %=== Things that are the same for z=2,3,4  
% % % % % % %       % dLB_0 = H*pi/B;
% % % % % % %         x_new(2,:) = (pi*x_new(6,:)) ./ (x_new(5,:));
% % % % % % %     
% % % % % % %    end
% % % % % % % elseif z == 5   % RockFM  dLB_t = 0; dD_t = 0    
% % % % % % %     x_new(2,:) = x(2,:) * 0;
% % % % % % %     x_new(4,:) = x(4,:) * 0;
% % % % % % % end
% % % % % % % 
% % % % % % % x_new(1,:) = x(1,:) + x_new(2,:);   %% LB_t = LB_{t-1} + dLB_t
% % % % % % % x_new(3,:) = x(3,:) + x_new(4,:);   %% D_t = D_{t-1} + dD



% % % % % % % % disp(x);
% % % % % % % % no changes for z==1 (Flat) or z==6 (RockMR).
% % % % % % % if z == 2 | z == 3 | z == 4      % RockF | RockM | RockR   
% % % % % % %     
% % % % % % %     pisqr_over_Bsqr = zeros(1,size(x,2));
% % % % % % %     for i=1:size(x,2)
% % % % % % %         pisqr_over_Bsqr(1,i) = pi^2/(x_new(5,i).^2);
% % % % % % %     end
% % % % % % % 
% % % % % % %   % dLB_t = dLB_{t-1} - pi^2/B_{t}^2*LB_{t-1};
% % % % % % %     x_new(2,:) = x(2,:) - pisqr_over_Bsqr .* x(1,:);
% % % % % % %   % dD_t = dD_{t-1} - pi^2/B_{t}^2*D_{t-1}; 
% % % % % % %     x_new(4,:) = x(4,:) - pisqr_over_Bsqr .* x(3,:);
% % % % % % % else % gradient is 0
% % % % % % %     x_new(2,:) = 0 * x_new(2,:);
% % % % % % %     x_new(4,:) = 0 * x_new(4,:);
% % % % % % % end
% % % % % % % 
% % % % % % % if z~=z_before % just transitioned to this state
% % % % % % %     if (z == 2 | z == 3 | z == 4)
% % % % % % %         %=== Things that are the same for z=2,3,4  
% % % % % % %         % B_0 = 8         
% % % % % % %         [N M] = size(x_new(5,:));
% % % % % % %         x_new(5,:) = 8*ones(N,M);    
% % % % % % %  % RD: Added this to copy value into x. Should have noise
% % % % % % %         x(5,:) = 8*ones(N,M);                
% % % % % % %         if z == 2   % RockF
% % % % % % %             % H_0 = -0.2
% % % % % % %             x_new(6,:) = -0.2*ones(N,M);                
% % % % % % %         elseif z == 3 %RockM
% % % % % % %             % H_0 = 0.4
% % % % % % %             x_new(6,:) = 0.4*ones(N,M);                
% % % % % % %         elseif z == 4  %RockR
% % % % % % %             % H_0 = -0.25
% % % % % % %             x_new(6,:) = -0.25*ones(N,M);                
% % % % % % %         end
% % % % % % % % RD: Added this to copy value into x. Should have noise
% % % % % % %         x(6,:) = x_new(6,:);                
% % % % % % %         % dLB_0 = H*pi/B;
% % % % % % %         x_new(2,:) = (pi*x(6,:)) ./ x(5,:);
% % % % % % % 
% % % % % % %         %=== Things that are different for z=2,3,4  
% % % % % % %         if z == 2   % RockF
% % % % % % %             % dD_0 = H*pi/(2*B); 
% % % % % % %             x_new(4,:) = (pi*x(6,:)) ./ (2*x(5,:));
% % % % % % %         elseif z == 3 %RockM
% % % % % % %             % dD_0 = H*pi/(-4*B); 
% % % % % % %             x_new(4,:) = (pi*x(6,:)) ./ (-4*x(5,:));
% % % % % % %         elseif z == 4  %RockR
% % % % % % %             % dD_0 = -0.8*H*pi/B; 
% % % % % % %             x_new(4,:) = (-0.8*pi*x(6,:)) ./ (x(5,:));          
% % % % % % %         end
% % % % % % %     else
% % % % % % %         x_new(2,:) = x(2,:) * 0; % don't have to care about matrix size this way.
% % % % % % %         x_new(4,:) = x(4,:) * 0;
% % % % % % %         % don't like this at all, but it'll do for now
% % % % % % %         x(1,:) = x(1,:) * 0;
% % % % % % %         x(3,:) = x(3,:) * 0;
% % % % % % %     end
% % % % % % % end
% % % % % % % %elseif z == 5   % RockFM  dLB_t = 0; dD_t = 0    
% % % % % % % %    x_new(2,:) = x(2,:) * 0; % don't have to care about matrix size this way.
% % % % % % % %    x_new(4,:) = x(4,:) * 0;
% % % % % % % %end
% % % % % % % 
% % % % % % % x_new(1,:) = x(1,:) + x_new(2,:);   %% LB_t = LB_{t-1} + dLB_t
% % % % % % % x_new(3,:) = x(3,:) + x_new(4,:);   %% D_t = D_{t-1} + dD
% % % % % % % 
% % % % % % % % disp(x_new);

% % % no changes for z==1 (Flat) or z==6 (RockMR).
% % if z == 2 | z == 3 | z == 4      % RockF | RockM | RockR   
% %     B = 10;
% %     pisqr_over_Bsqr = zeros(1,size(x,2));
% %     for i=1:size(x,2)
% %         pisqr_over_Bsqr(1,i) = pi^2/B^2;
% %     end
% % %pisqr_over_Bsqr
% %   % dLB_t = dLB_{t-1} - pi^2/B_{t}^2*LB_{t-1};
% %     x_new(2,:) = x(2,:) - pisqr_over_Bsqr .* x(1,:);
% %   % dD_t = dD_{t-1} - pi^2/B_{t}^2*D_{t-1}; 
% %     x_new(4,:) = x(4,:) - pisqr_over_Bsqr .* x(3,:);
% %   
% %     if z~=z_before & (z == 2 | z == 3 | z == 4)
% %         [N M] = size(x(6,:));
% %         %=== Things that are different for z=2,3,4  
% %         if z == 2   % RockF
% %           % H_0 = -0.2
% %             x_new(6,:) = -0.2*ones(N,M);                
% %           % dD_0 = H*pi/(2*B); 
% %             x_new(4,:) = (pi*x_new(6,:)) ./ (2*B);
% %         elseif z == 3 %RockM
% %           % H_0 = 0.4
% %             x_new(6,:) = 0.4*ones(N,M);                
% %           % dD_0 = H*pi/(-4*B); 
% %             x_new(4,:) = (pi*x_new(6,:)) ./ (-4*B);
% %         elseif z == 4  %RockR
% %           % H_0 = -0.25
% %             x_new(6,:) = -0.25*ones(N,M);                
% %           % dD_0 = -0.8*H*pi/B; 
% %             x_new(4,:) = (-0.8*pi*x_new(6,:)) ./ B;          
% %        end
% %       %=== Things that are the same for z=2,3,4  
% %       % dLB_0 = H*pi/B;
% %         x_new(2,:) = (pi*x_new(6,:)) ./ B;
% %     
% %    end
% % elseif z == 5   % RockFM  dLB_t = 0; dD_t = 0    
% %     x_new(2,:) = x(2,:) * 0;
% %     x_new(4,:) = x(4,:) * 0;
% % end
% % 
% % x_new(1,:) = x(1,:) + x_new(2,:);   %% LB_t = LB_{t-1} + dLB_t
% % x_new(3,:) = x(3,:) + x_new(4,:);   %% D_t = D_{t-1} + dD



% if z == 1
%     x_new = 0.9999*x + 1;
% elseif z == 2
%     x_new = 0.9998*x+1;
% elseif z == 3
%     x_new = 0.9997*x+1;
% elseif z == 4
%     x_new = 0.9996*x+1;
% elseif z == 5
%     x_new = 0.9995*x+1;
% elseif z == 6
%     x_new = 0.9994*x+1;
% end;