function x_new = ut_ffun(z,z_before,x,par,u,pn);
% 6 cts variables: 1=LBogeyAngle (LB), 2=dLBogeyAngle (dLB), 3=DiffAngle (D), 
%                  4=dDiffAngle (dD), 5=RockWidth (B), 6=RockHeight (H)
% 6 modes: 1=Flat, 2=RockF, 3=RockM, 4=RockR, 5=RockFM, 6=RockMR

x_new = x; % if something is not changed it just keeps the old value.

[N M] = size(x_new(1,:));
if z == 2 & z~=z_before % new rock
    % get estimate of new rock's length.
    if z ~= z_before
        % B_0 = 8         
        x_new(5,:) = 8*ones(N,M);  % mean 8
    end
    x_new(5,:) = x_new(5,:) + pn(5,:);  % add process noise.
else % old rock. Just noise that enables us to change our estimate.
    x_new(5,:) = x(5,:) + pn(5,:);
end


if z~=z_before % just transitioned to this state
    if (z == 2 | z == 3 | z == 4)  % rock starting at one of the wheels
      % estimate the height.
        if z == 2   % RockF
            % H_0 = -0.2
            x_new(6,:) = -0.2*ones(N,M);                
        elseif z == 3 %RockM
            % H_0 = 0.4
            x_new(6,:) = 0.4*ones(N,M);                
        elseif z == 4  %RockR
            % H_0 = -0.25
            x_new(6,:) = -0.25*ones(N,M);                
        end
        % add process noise.
        x_new(6,:) = x_new(6,:) + pn(6,:);

     % compute initial gradients w.r.t. height and length
       % dLB_0 = H*pi/B;
        x_new(2,:) = (pi*x_new(6,:)) ./ x_new(5,:); % noise added later.

        if z == 2   % RockF
            % dD_0 = H*pi/(2*B); 
            x_new(4,:) = (pi*x_new(6,:)) ./ (2*x_new(5,:)); % noise added later.
        elseif z == 3 %RockM
            % dD_0 = H*pi/(-4*B); 
            x_new(4,:) = (pi*x_new(6,:)) ./ (-4*x_new(5,:));
        elseif z == 4  %RockR
            % dD_0 = -0.8*H*pi/B; 
            x_new(4,:) = (-0.8*pi*x_new(6,:)) ./ (x_new(5,:));          
        end
    else % flat or intermediate state. there shouldn't be any differentials 
         % anymore and the angles should be around zero.
        x_new(2,:) = x(2,:) * 0; % noise added later.
        x_new(4,:) = x(4,:) * 0;

        x(1,:) = x(1,:) * 0; % this is awful. bad hack. change it later! don't change input params.
        x(3,:) = x(3,:) * 0;
        
        x_new(6,:) = x(6,:) + pn(6,:); % only for completeness.
    end
else    % have been in this state before.
	if z == 2 | z == 3 | z == 4      % RockF | RockM | RockR   
        pisqr_over_Bsqr = zeros(1,size(x,2));
        for i=1:size(x,2)
            pisqr_over_Bsqr(1,i) = pi^2/(x_new(5,i).^2);
        end
	
      % update gradients; these lines come from differential equations.
      % dLB_t = dLB_{t-1} - pi^2/B_{t}^2*LB_{t-1};
        x_new(2,:) = x(2,:) - pisqr_over_Bsqr .* x(1,:);
      % dD_t = dD_{t-1} - pi^2/B_{t}^2*D_{t-1}; 
        x_new(4,:) = x(4,:) - pisqr_over_Bsqr .* x(3,:);
	else % gradient is 0
        x_new(2,:) = 0 * x_new(2,:);% noise added later.
        x_new(4,:) = 0 * x_new(4,:);
	end
    x_new(6,:) = x(6,:) + pn(6,:); % height stays the same for the rock.
end

x_new(2,:) = x_new(2,:) + pn(2,:); % add process noise.
x_new(4,:) = x_new(4,:) + pn(4,:); % add process noise.

x_new(1,:) = x(1,:) + x_new(2,:);   %% LB_t = LB_{t-1} + dLB_t
x_new(3,:) = x(3,:) + x_new(4,:);   %% D_t = D_{t-1} + dD

x_new(1,:) = x_new(1,:) + pn(1,:); % add process noise.
x_new(3,:) = x_new(3,:) + pn(3,:); % add process noise.

% disp(x_new);

% % % % % % % no changes for z==1 (Flat) or z==6 (RockMR).
% % % % % % if z == 2 | z == 3 | z == 4      % RockF | RockM | RockR   
% % % % % %     B = 10;
% % % % % %     pisqr_over_Bsqr = zeros(1,size(x,2));
% % % % % %     for i=1:size(x,2)
% % % % % %         pisqr_over_BSqr(1,i) = pi^2/B^2;
% % % % % %     end
% % % % % % 
% % % % % %   % dLB_t = dLB_{t-1} - pi^2/B_{t}^2*LB_{t-1};
% % % % % %     x_new(2,:) = x(2,:) - pisqr_over_Bsqr .* x(1,:);
% % % % % %   % dD_t = dD_{t-1} - pi^2/B_{t}^2*D_{t-1}; 
% % % % % %     x_new(4,:) = x(4,:) - pisqr_over_Bsqr .* x(3,:);
% % % % % %   
% % % % % %     if z~=z_before & (z == 2 | z == 3 | z == 4)
% % % % % %       %=== Things that are the same for z=2,3,4  
% % % % % %       % dLB_0 = H*pi/B;
% % % % % %         x_new(2,:) = (pi*x(6,:)) ./ B;
% % % % % % 
% % % % % %         [N M] = size(x_new(5,:));
% % % % % % 
% % % % % %         %=== Things that are different for z=2,3,4  
% % % % % %         if z == 2   % RockF
% % % % % %           % dD_0 = H*pi/(2*B); 
% % % % % %             x_new(4,:) = (pi*x(6,:)) ./ (2*B);
% % % % % %           % H_0 = -0.2
% % % % % %             x_new(6,:) = -0.2*ones(N,M);                
% % % % % %         elseif z == 3 %RockM
% % % % % %           % dD_0 = H*pi/(-4*B); 
% % % % % %             x_new(4,:) = (pi*x(6,:)) ./ (-4*B);
% % % % % %           % H_0 = 0.4
% % % % % %             x_new(6,:) = 0.4*ones(N,M);                
% % % % % %         elseif z == 4  %RockR
% % % % % %           % dD_0 = -0.8*H*pi/B; 
% % % % % %             x_new(4,:) = (-0.8*pi*x(6,:)) ./ B;          
% % % % % %           % H_0 = -0.25
% % % % % %             x_new(6,:) = -0.25*ones(N,M);                
% % % % % %        end
% % % % % %     end
% % % % % % elseif z == 5   % RockFM  dLB_t = 0; dD_t = 0    
% % % % % %     x_new(2,:) = x(2,:) * 0; % don't have to care about matrix size this way.
% % % % % %     x_new(4,:) = x(4,:) * 0;
% % % % % % end
% % % % % % 
% % % % % % x_new(1,:) = x(1,:) + x_new(2,:);   %% LB_t = LB_{t-1} + dLB_t
% % % % % % x_new(3,:) = x(3,:) + x_new(4,:);   %% D_t = D_{t-1} + dD



% % % if z == 1
% % %     x_new = x;
% % % elseif z == 2
% % %     x = 0.9*x;
% % % elseif z == 3
% % %     x = 0.8*x;
% % % elseif z == 4
% % %     x = 0.7*x;
% % % elseif z == 5
% % %     x = 1.1*x;
% % % elseif z == 6
% % %     x = 1.2*x;
% % % end;
% % % x_new = x;

% % % % % % % x_new = ffun(z,z_before,x,par,u) + pn;